| GlsMap Toolkit 1.10.2

Public Member Functions | Protected Attributes | List of all members
disti::AifMapChartDataSource Class Reference
AIF

`#include <gls_map_aif.h>`

Inheritance diagram for disti::AifMapChartDataSource:

## Public Member Functions
| AifMapChartDataSource (bool UseDefaultCache=true)
| ~AifMapChartDataSource () DISTI_METHOD_OVERRIDE
void | LoadAifFile (std::string filename)
virtual void | SetCache (AIFMapChartLayerCache &cache)
bool | GetAvailableCoverage (GeoRect *dest) DISTI_METHOD_OVERRIDE
void | GetCellList (const GeoRect &coverage, unsigned long layerID, double viewLogicalHeight, double viewGeoHeight, MapChartCellList &viewList) DISTI_METHOD_OVERRIDE
void | AddOverlay (const std::string &overlay, double resolution)
void | InsertOverlay (int index, const std::string &overlay, double resolution)
void | RemoveOverlay (const std::string &overlay, double resolution)
void | RemoveOverlay (const std::string &overlay)
void | RemoveOverlay (double resolution)
void | SetCacheSize (const float memSize)
float | GetCacheSize () const
float | GetCurrentCacheAllocated ()
void | InstallViewManager (AIFViewManager &mgr)
void | UninstallViewManager ()
void | PreCache (const GeoRect &area)
void | PreCache (const double resolution)
void | SetTargetCellLoadRate (const double targetCellLoadRate)
double | GetTargetCellLoadRate () const
Public Member Functions inherited from disti::GlsMapChartDataSource
virtual | ~GlsMapChartDataSource ()
virtual bool | GetAvailableCoverage (GeoRect *dest)=0
virtual unsigned long | GetBestLayer (GlsMapView *view, GlsMapChart *chart) const
virtual void | GetCellList (const GeoRect &coverage, unsigned long layerID, double viewLogicalHeight, double viewGeoHeight, MapChartCellList &viewList)=0
virtual void | PostDraw (GlsMapView *view, GlsMapChart *chart)
virtual bool | AreAllCellsLoaded (GlsMapView *view, GlsMapChart *chart)

## Protected Attributes
OverlayCellMultiMap | _cells
ResolutionList | _resolutionList
GeoRect | _extents
OverlayListType | _overlayList
AIFMapChartLayerCache * | _pCache
AIFViewManager * | _pViewMgr
bool | _usingDefaultCache

## Additional Inherited Members
Protected Member Functions inherited from disti::GlsMapChartDataSource
| GlsMapChartDataSource ()

## Detailed Description

Runtime implementation of an AifMapChartDataSource

## Constructor & Destructor Documentation

## ◆ AifMapChartDataSource()

AifMapChartDataSource::AifMapChartDataSource | ( | bool | UseDefaultCache = `true` | ) |

Create a new AifMapChartDataSource.

Parameters

  UseDefaultCache | whether to use the default caching system. See AIFMapChartLayerCache for more information

## Member Function Documentation

## ◆ AddOverlay()

void AifMapChartDataSource::AddOverlay | ( | const std::string & | overlay,
|  | double | resolution
| ) |  |

Add an overlay layer to the list of layers to display.

Parameters

  overlay | The name of the overlay layer to display. Must correspond to an overlay defined in the AIF file.
  resolution | The resolution of the overlay to display. Must correspond to a resolution of an overlay defined in the AIF file.

## ◆ GetAvailableCoverage()

bool AifMapChartDataSource::GetAvailableCoverage | ( | GeoRect * | dest | ) |
| virtual

See base class.

Implements disti::GlsMapChartDataSource.

## ◆ GetCellList()

void AifMapChartDataSource::GetCellList | ( | const GeoRect & | coverage,
|  | unsigned long | layerID,
|  | double | viewLogicalHeight,
|  | double | viewGeoHeight,
|  | MapChartCellList & | viewList
| ) |  |
| virtual

See base class.

Implements disti::GlsMapChartDataSource.

## ◆ GetTargetCellLoadRate()

double AifMapChartDataSource::GetTargetCellLoadRate | ( |  | ) | const

Get the target rate in hz at which cells will be loaded

Returns
  target rate in hz else 0.0 for no target rate ( i.e. load as quickly as possible )

## ◆ InsertOverlay()

void AifMapChartDataSource::InsertOverlay | ( | int | index,
|  | const std::string & | overlay,
|  | double | resolution
| ) |  |

Insert an overlay layer to the list of layers to display at the given position.

Parameters

  index | The index to insert the overlay at, if -1 or greater than the length of the overlay list then inserts at end.
  overlay | The name of the overlay layer to display. Must correspond to an overlay defined in the AIF file.
  resolution | The resolution of the overlay to display. Must correspond to a resolution of an overlay defined in the AIF file.

## ◆ InstallViewManager()

void AifMapChartDataSource::InstallViewManager | ( | AIFViewManager & | mgr | ) |

Install the view manager. The view manager (after being initialized by the user) will set this class up to add/remove overlays automatically based on the view height

Parameters

  mgr | Manager to install

## ◆ LoadAifFile()

void AifMapChartDataSource::LoadAifFile | ( | std::string | filename | ) |

Load an AIF File with the given file name.

Parameters

  filename | The name of the AIF file to load. Can be absolute or relative to the executing directory.

## ◆ PreCache() [1/2]

void AifMapChartDataSource::PreCache | ( | const double | resolution | ) |

Precache based on resolution

Parameters

  resolution | Resolution to precache at.

## ◆ PreCache() [2/2]

void AifMapChartDataSource::PreCache | ( | const GeoRect & | area | ) |

Precache based on geo-rect area. This uses the AIFMapChartCache as the mechanism to precache images

Parameters

  area | Geometric rect area to pre-cache

## ◆ RemoveOverlay() [1/3]

void AifMapChartDataSource::RemoveOverlay | ( | const std::string & | overlay | ) |

Remove all overlay layers with the given overlay name.

Parameters

  overlay | The name of the set of overlay layers to remove.

## ◆ RemoveOverlay() [2/3]

void AifMapChartDataSource::RemoveOverlay | ( | const std::string & | overlay,
|  | double | resolution
| ) |  |

Remove an overlay layer from the list of layers to display.

Parameters

  overlay | The name of the overlay layer to remove. Must correspond to an overlay defined in the AIF file.
  resolution | The resolution of the overlay to remove. Must correspond to a resolution of an overlay defined in the AIF file.

## ◆ RemoveOverlay() [3/3]

void AifMapChartDataSource::RemoveOverlay | ( | double | resolution | ) |

Remove all overlay layers with the given resolution.

Parameters

  resolution | The resolution of the set of overlay layers to remove.

## ◆ SetCache()

void AifMapChartDataSource::SetCache | ( | AIFMapChartLayerCache & | cache | ) |
| virtual

If using custom cache, set it here. Caller responsible for its deallocation if necessary

Parameters

  cache | Custom cache to use

## ◆ SetCacheSize()

void AifMapChartDataSource::SetCacheSize | ( | const float | memSize | ) |

Parameters

  memSize | Set the cached size (megabytes) of images

## ◆ SetTargetCellLoadRate()

void AifMapChartDataSource::SetTargetCellLoadRate | ( | const double | targetCellLoadRate | ) |

Set the target rate in hz at which cells will be loaded

Parameters

  targetCellLoadRate | target rate in hz else 0.0 for no target rate ( i.e. load as quickly as possible )

## Member Data Documentation

## ◆ _resolutionList

ResolutionList disti::AifMapChartDataSource::_resolutionList
| protected

A list of the resolutions in this AIF file for speeding up the selection of a resolution at cell load list time.

The documentation for this class was generated from the following files:

- gls_map_aif.h
- gls_map_aif.cpp